--local moonshine = require 'moonshine'
local maf = require 'maf'

local t = 0
local vt = 0
local demopart = 0
local _dt = 0
local loadcursor = 0
local firstdraw = 1
local pointindex = 1

local vectors_src = {}
local vectors_tgt = {}
local is_morph = {}
local morphtime = {}
local points_x = {}
local points_y = {}
local points_z = {}

local palette_r = {}
local palette_g = {}

function update_load()
end
 
function love.load()
--    canvas = love.graphics.newCanvas(320, 240)

--	effect = moonshine(moonshine.effects.crt)

	mainFont = love.graphics.newFont("main.ttf", 20)

    love.graphics.clear()
    love.graphics.setColor(255,255,255)
    love.graphics.setFont(mainFont);
    love.graphics.print('Loading...', 110,85)
    love.graphics.present()

	skrollilogo = love.graphics.newImage( "skrolli.png" )
	quadlogo = love.graphics.newImage( "quadlogo.png" )
	city = love.graphics.newImage( "city.png" )
	nebu = love.graphics.newImage( "nebu.png")
    update_load()

    init_vector()
    for i=1,100 do
    	palette_r[i] = i*1.5
    	palette_g[i] = i*1.3

    	love.graphics.setColor(palette_r[i],palette_g[i],192)
    end

    love.audio.setVolume(64)
end

function draw_center_x(pic,xo,y,yo)
	clip = love.graphics.newQuad(0,yo,pic:getWidth(),1)

	love.graphics.draw(pic,clip,160-pic:getWidth()/2+xo, y)
end

local logotick = 0
local yoo = 0
local scrollx = 0
local fader = 0

function do_intro() 
	local width = love.graphics.getWidth()
	local height = love.graphics.getHeight()

	love.graphics.setBlendMode("normal")

    local x, y = 290-skrollilogo:getWidth()/2,130-skrollilogo:getHeight()/2
    x=-238+t*50+math.cos(x+t)*100
    if x > 160 then x = 160 logotick = logotick + _dt end

	if x == 160 and logotick > 4 and logotick < 8 then
		if logotick >= 6 then yoo=(logotick-6)*64 end
     end

    if logotick < 10 then

	    for i=0,skrollilogo:getHeight() do
	    	xo = math.cos(i*0.2+-2+t*0.2+x*0.1)*math.sin(-2+t*0.3+x*0.1)*(0.5-((x-160)*0.05))
	    	if -2+t*0.3 > 0.0 then xo = 0 end

		    draw_center_x(skrollilogo,-160+x+xo,i+32-yoo,i)
	    end
   end

    if logotick >= 12 then
		offs = quadlogo:getHeight()*(logotick-12)
		if offs > quadlogo:getHeight() then offs = quadlogo:getHeight() end
	    for i=0,offs do
	    	xo = math.cos(i+-2+t*0.2)*math.sin(-2+t*0.3)*10
	    	if -2+t*0.3 > 0.0 then xo = 0 end
	    	if logotick >= 12 then xo = math.cos(i*(logotick-12))*(logotick-12) end

    		if logotick < 14 then yoo = 0 end
    		if logotick >= 14 then yoo = (logotick-14)*16 end

		    draw_center_x(quadlogo,xo+yoo,90-quadlogo:getHeight()+i*2-yoo,i+yoo)
	    end

	end    	

--	if logotick < 12 then
--		love.graphics.setBlendMode("color")
--	    scrollx = 500-t*100
--	    love.graphics.setColor(64, 32, 92)
--	    love.graphics.print('the power of scripted languages upon your disk operating system. Welcome everybody! *** Skrolliparty 2018 ***', scrollx+math.cos(t*5)*15, 170)
--	    love.graphics.setColor(64*2.3, 32*2.5, 92*2.3)
--	    love.graphics.print('the power of scripted languages upon your disk operating system. Welcome everybody! *** Skrolliparty 2018 ***', -1+scrollx+math.cos(t*5)*15, -1+170)
--	end


	if logotick > 20.5 and demopart == 0 then
		demopart = 1
		vt = -3
		love.graphics.resetPalette()
	end
end

local pointcount = 35
local curpoints = 1

function calc_point(a,i)
	local x,y,z = a:unpack()

	local u = (x / z)*320;
	local v = (y / z)*200;

	points_x[i] = u
	points_y[i] = v
	points_z[i] = 4+(u + v)/64
	pointindex=pointindex+1
end

function get_vector(i)
	local a = maf.vector(0.51+math.sin(i*0.1+t)*0.3+0.2*math.sin(t*0.5),0.51+math.cos(i*0.1+t)*0.3+0.2*math.cos(t*0.5), 1.0)
	return a
end

function init_vector( )
	for i=1,pointcount do
		local a = get_vector(i)
		vectors_src[i] = maf.vector(0,0,1.0)
		vectors_tgt[i] = a
		is_morph[i] = 0
		morphtime[i] = 0
	end
end

function init_vector_one(i)
	local a = get_vector(i)
	vectors_tgt[i] = a
end


function clamp_uv(u,v) 
	if u > 319 then u = 319 end
	if v > 199 then v = 199 end
	if u < 0 then u = 0 end
	if v < 0 then v = 0 end
	return u,v
end


function do_vector()
	if vt < 0 then return end
	local rx = math.cos(vt*0.1)
	local ry = vt*0.1
	local rz = vt*0.1
	local offx = 0.0

	if vt >= 28 then
		offx = (vt-28.)*0.4
	end

	of = maf.vector(-0.5,-0.5,offx)
	local r = maf.rotation.fromAngleAxis(0.1,0.1,0.05-vt*0.012,rx)

	local px,py = 0
	curpoints = 1+vt*3.8
	if curpoints > pointcount then curpoints = pointcount end




	for i=1,pointcount do
		local a = vectors_src[i]
		if is_morph[i] == 1 and morphtime[i] <= 1 then
			a = a:lerp(vectors_tgt[i],morphtime[i])
			
			morphtime[i] = morphtime[i] + _dt*0.6
			if morphtime[i] >= 1.0 then
				is_morph[i] = 0
				morphtime[i] = 0
			end
		end

		a:add(of)
		a:rotate(r)
		a:sub(of)

		calc_point(a,i)
	end

	if vt >= 20 then 
		curpoints=curpoints-((vt-20)*2.9)
	end

	for i=1,curpoints do
		local u = points_x[i]
		local v = points_y[i]
		if i == 1 then 
			px = u
			py = v 
		end

		if (u >= 314 or v >= 194 or u <= 10 or v <= 10) and is_morph[i] == 0 then
			is_morph[i] = 1
			morphtime[i] = 0
			init_vector_one(i)
		end

			u,v = clamp_uv(u,v)

			love.graphics.setColor(palette_r[math.floor(v*0.5)],palette_g[math.floor(v*0.5)],192)
			love.graphics.line(u,v,px,py)
			love.graphics.setColor(32+32*morphtime[i],32,32)
			cs = points_z[i]
			love.graphics.circle('fill',u,v,cs)
			px = u
			py = v
	end


	if vt > 32.5 then 
		demopart = 2 
		t = 0
		love.graphics.resetPalette() 
		love.graphics.setBackgroundColor(0,0,0)
		love.graphics.setColor(0,0,0)

		spacee = love.graphics.newImage( "space.png" )
	end

end

function test_clamp_uv(u,v,o) 
	local tt = 0
	if u > 319+o then tt = 1 end
	if v > 199+o then tt = 1 end
	if u < 0-o then tt = 1 end
	if v < 0-o then tt = 1 end
	return tt
end


function calc_point_spin(a)
	local x,y,z = a:unpack()

	local u = (x / z)*320;
	local v = (y / z)*200;

	local z = 1.0-z
	return u,v,z
end

function do_spinner()
	local rx = t*0.1

	love.graphics.draw(spacee,0,0)

	of = maf.vector(-0.5,-0.5,-1.0)
	local r = maf.rotation.fromAngleAxis(t*2.,0.0,0.0,1.0)

	local sto = -t*6
	local max = t*6
	if max > 24 then max = 24 end
	local eka = 1
	for i=sto,sto+max do
		local a = maf.vector(0.5+math.cos(i*0.2)*0.3,0.5+math.sin(i*0.2)*0.3,1.0+math.cos(i*0.1+t)*0.2)
		a:add(of)
		a:rotate(r)
		a:sub(of)

		local u,v,z = calc_point_spin(a)
		local cs = (2.-z)*16+math.cos(i*0.1+t)*8
		tt = test_clamp_uv(u,v,cs)
		cs = math.floor(cs)

		eka = 1
		if i == sto+max then eka = 0 end


		if eka == 1 then 
			love.graphics.setColor(math.cos(cs)*255,192,-128+cs*4)
			if tt == 0 then love.graphics.circle('fill',u,v,cs) end
		else
			love.graphics.setColor(math.cos(cs)*255,192,-128+cs*4)
			if tt == 0 then love.graphics.circle('fill',u,v,cs) end
			love.graphics.setColor(0,0,0)
			if tt == 0 then love.graphics.circle('fill',u,v,cs-2-7+8*math.abs(math.cos(t*4+math.sin(t*1)))) end
		end

	end

	if t > 6 then 
	love.graphics.setColor(152,24,132)
	love.graphics.print("Ouroboros",1,1)
	love.graphics.setColor(192,64,192)
	love.graphics.print("Ouroboros",0,0)
	end


	if t > 10 and t < 20 then 
	love.graphics.setColor(24,152*0.7,132*0.5)
	love.graphics.print("the mighty wyrm",131,181)
	love.graphics.setColor(64,192*0.7,192*0.5)
	love.graphics.print("the mighty wyrm",130,180)
	end

	if t > 14 and t < 19 then 
	love.graphics.setColor(152,24,132)
	love.graphics.print("always chasing",131,181-20)
	love.graphics.setColor(192,64,192)
	love.graphics.print("always chasing",130,180-20)
	end

	if t > 18 and t < 22 then 
	love.graphics.setColor(152*0.5,24,132*0.5)
	love.graphics.print("never reaching",131,181-40)
	love.graphics.setColor(192*0.5,64,192*0.5)
	love.graphics.print("never reaching",130,180-40)
	end


	if t > 26 then 
		demopart = 3
		t = 0
		love.graphics.resetPalette() 
	end
end

function draw_scroll(pic,xo,yo,w,h,x,y)
	clip = love.graphics.newQuad(xo,yo,w,h)
	love.graphics.draw(pic,clip,x, y)
end


function do_city()
-- 	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.setBlendMode("normal")
	local zo = t*4.5
	if (zo > 64) then zo = 64 end
	if demopart == 2 then zo = 0 end
	local wiper = 0
	if (logotick > 16) then wiper = (logotick-16)*0.25 end
	if demopart == 0 then draw_scroll(nebu,0,zo*0.5,320,(112+zo*0.3)-wiper*115,0,0) end

	local scro = 1

	if logotick >= 18 then 
		scro = 1.0-((logotick-18)*0.1)
	end

	if scro < 0.0 then scro = 0.0 end

	scrollx = math.floor(t*40)*scro
	scrollx = scrollx % 320
	
	buildings_y = 100+zo*0.25
	lights_y = buildings_y+16

	draw_scroll(city,scrollx,64,320-scrollx,16,0,buildings_y)
	draw_scroll(city,0,64,scrollx,16,320-scrollx,buildings_y)

	for yy=1,24,2 do
		scrollx2 = (math.floor(t*(50+yy*4)))*scro
		scrollx2 = scrollx2 % 320
		draw_scroll(city,scrollx2,80+yy,320-scrollx2,2,0,lights_y+yy*(100.0+zo)*0.01)
		draw_scroll(city,0,80+yy,scrollx2,2,320-scrollx2,lights_y+yy*(100.0+zo)*0.01)

	end

	do_intro()
end


local _s = {
	0,0,8,8,8,8,
	0,7,0,0,0,0,
	0,0,6,6,6,0,
	0,0,0,0,0,5,
	0,0,0,0,0,4,
	0,1,1,1,1,0,
	0,0,0,0,0,0,

}

local _k = {
	0,0,8,0,0,6,
	0,0,8,0,0,6,
	0,0,8,0,6,0,
	0,0,8,7,0,0,
	0,0,8,0,6,0,
	0,0,8,0,0,6,
	0,0,0,0,0,0,

}

local _r = {
	0,0,8,8,8,8,
	0,0,8,0,0,7,
	0,0,8,0,0,6,
	0,0,8,6,6,0,
	0,0,8,0,6,0,
	0,0,8,0,0,6,
	0,0,0,0,0,0,
}

local _o = {
	0,0,0,8,8,0,
	0,0,8,0,0,7,
	0,0,8,0,0,7,
	0,0,8,0,0,7,
	0,0,8,0,0,8,
	0,0,0,8,8,0,
	0,0,0,0,0,0,
}

local _l = {
	0,0,8,0,0,0,
	0,0,7,0,0,0,
	0,0,6,0,0,0,
	0,0,5,0,0,0,
	0,0,4,0,0,0,
	0,0,4,4,4,4,
	0,0,0,0,0,0,
}


local _i = {
	0,0,0,8,8,0,
	0,0,0,0,0,0,
	0,0,0,6,6,0,
	0,0,0,5,5,0,
	0,0,0,4,4,0,
	0,0,0,4,4,0,
	0,0,0,0,0,0,
}

local shole = {
	0,0,7,8,6,6,
	0,7,0,4,4,0,
	0,6,4,0,0,8,
	0,8,4,0,0,6,
	0,7,0,4,4,0,
	0,0,8,6,7,8,
	0,0,0,0,0,0,

}

local emmp = {
	0,0,5,0,5,0,
	0,0,5,0,5,0,
	0,0,5,0,5,0,
	0,0,0,0,0,0,
	0,8,0,0,0,8,
	0,0,5,3,5,0,
	0,0,0,0,0,0,

}

local endd = {
	0,0,0,0,0,0,
	0,0,0,0,0,0,
	0,0,0,5,0,0,
	0,0,0,0,0,0,
	0,0,0,0,0,0,
	0,0,0,0,0,0,
	0,0,0,0,0,0,
}

local shapes = {endd,emmp,_s,_k,_r,_o,_l,_l,_i,emmp,endd}
local shapeindex = 1
local order_xyss = {}
local order_z = {}

function z_compare(a,b)
  return a > b
end

local sort_relative = function(ref, t, cmp)
    local n = #ref
    assert(#t == n)
    local r = {}
    for i=1,n do r[i] = i end
    if not cmp then cmp = function(a, b) return a < b end end
    table.sort(r, function(a, b) return cmp(ref[a], ref[b]) end)
    for i=1,n do r[i] = t[r[i]] end
    return r
end

local shapeaccum = 0

local shapefirst = 1

function do_spinner2()
	local rx = t*0.1
	love.graphics.setBlendMode("normal")
	love.graphics.setBackgroundColor(4,12,4)
	love.graphics.clear()

	of = maf.vector(-0.5,-0.5,-1.0)
	local r = maf.rotation.fromAngleAxis(t*2.,0.1,0.0,0.2)
	local r2 = maf.rotation.fromAngleAxis(3.14,0.0,0.0,1.0)
	shapeaccum = shapeaccum + _dt*2.
	if shapeaccum > 3.1415 and shapefirst == 1 then shapeindex = shapeindex + 1 shapeaccum = 0 shapefirst = 0 end
	if shapeaccum > 3.1415*2 and shapefirst == 0 then shapeindex = shapeindex + 1 shapeaccum = 0 end
	local shape = shapes[shapeindex]

	if shapeindex > 10 then
		demopart = 4
		t = 0
		love.graphics.resetPalette()
		love.graphics.setColor(0,0,0)
		love.graphics.setBackgroundColor(0,0,0)
		stars_init = 0
		return
	end


	local count = 1
	for iy=1,6 do
		for ix=2,6 do
			ss = shape[6*6- (iy*6)+(8-ix)]
			if ss > 0 then
				local a = maf.vector(math.cos(t*4.+iy*0.01)*0.1+ix*(0.25/2.),-0.0+iy*0.15,1.0)
				a:add(of)
				a:rotate(r)
				a:rotate(r2)
				--a:scale(0.75+math.cos(t)*0.2)
				a:sub(of)

				local u,v,z = calc_point_spin(a)
				order_xyss[count] = {u,v,ss}

				order_z[count] = z

				count = count + 1
			end
		end
	end

--	table.sort( order_z, z_compare )
--	sort_relative(order_z, order_xyss)

	for i=1,count-1,1 do
		local u = order_xyss[i][1]
		local v = order_xyss[i][2]
		local ss = order_xyss[i][3]
		local z = order_z[i]
		if z < 0.5 then z = 0.5-z/4. end
		local cs = (0.2+z)*32
		cs = math.floor(cs)

		tt = test_clamp_uv(u,v,cs)
		if t > 1.5 then
		if palreset == 1 then
			palreset = 0
			love.graphics.resetPalette()
			love.graphics.setColor(0,0,0)
		end

		love.graphics.setColor(cs*6-ss*3+math.cos(i*0.1+t*0.1+u*0.1+v*0.1)*ss*t*0.02,cs*6-ss*5,cs*6-ss*5)
		else
		love.graphics.setColor((t*0.5)*92,(t*0.5)*92,(t*0.5)*92)
		end
		if tt == 0 then love.graphics.circle('fill',u,v,cs) end

	end



end

stars_x = {}
stars_y = {}
stars_speed = {}
star_pal = {}
stars_init = 0
starcount = 48
staro = 160
spread = 320
palcount = 255
palreset = 1
ta = 0
function init_star()
	local xx,yy,ss
	xx = staro+(math.random()-0.5)*spread
	yy = 300+(math.random()-0.5)*200
	ss = starspeed*(0.1+math.random()*0.75)
	return xx,yy,ss
end

no_new_spawn = 0

function do_stars()
		love.graphics.setBlendMode("or")

	starspeed = ((t+0.5)*0.2+10.)*10

	if stars_init == 0 then
		stars_init = 1

		for i=1,starcount+1 do
			stars_x[i], stars_y[i], stars_speed[i] = init_star()
		end

		--staro = -320

	end

	for i=1,starcount do
		if (stars_x[i] >= 0 and stars_x[i] < 320) then

			col = 64+math.floor(stars_speed[i]*0.5)*8
			love.graphics.setColor(col*2,col*2,col)
			love.graphics.point(stars_x[i],stars_y[i])
		end
		stars_x[i] = stars_x[i]+_dt*stars_speed[i]
		stars_y[i] = stars_y[i]-_dt*stars_speed[i+1]
		if stars_x[i] >= 320 and no_new_spawn == 0 then
			stars_x[i], stars_y[i], stars_speed[i] = init_star()
		end
	end

end

function init_star2() 
	local xx,yy,ss
	xx = staro+(math.random()-0.5)*spread
	yy = 300+(math.random()-0.5)*200
	ss = starspeed*(0.1+math.random()*0.75)
	return xx,yy,ss
end


function do_stars2()

	starspeed = ((t+0.5)*0.2+10.)*10

	if stars_init == 0 then
		stars_init = 1

		for i=1,starcount+1 do
			stars_x[i], stars_y[i], stars_speed[i] = init_star2()
		end

		--staro = -320

	end

	for i=1,starcount do
		if (stars_x[i] >= 0 and stars_x[i] < 320) then

			love.graphics.point(stars_x[i],stars_y[i])
		end
		stars_y[i] = stars_y[i]-_dt*stars_speed[i]
		if stars_y[i] < 0 then
			stars_x[i], stars_y[i], stars_speed[i] = init_star2()
		end
	end

end

fade1_d = 0
fade2_d = 0
fade3_d = 0

function do_credits()
	if t < 28 then
	fade1 = t-2
	fade2 = t-5.5
	fade3 = t-12
	end


	if fade1 < 0 then fade1 = 0 end
	if fade2 < 0 then fade2 = 0 end
	if fade3 < 0 then fade3 = 0 end

	if fade1 > 1 and fade1_d == 0 then fade1 = 1  end
	if fade2 > 1 and fade2_d == 0 then fade2 = 1  end
	if fade3 > 1 and fade3_d == 0 then fade3 = 1  end

	if t > 4 and fade1_d == 0 then
	fade1 = 1-(t-4)*0.8
	if fade1 < 0 then
		fade1_d = 1
		love.graphics.resetPalette()
		love.graphics.setColor(0,0,0)
	end
	end

	if t > 12 and fade2_d == 0 then
	fade2 = 1-(t-12)*0.7
	if fade2 < 0 then
		fade2_d = 1
		love.graphics.resetPalette()
		love.graphics.setColor(0,0,0)
	end
	end

	if t > 17 and fade3_d == 0 then
	fade3 = 1-(t-17)*0.6
	if fade3 < 0 then
		fade3_d = 1
	end
	end


	if t > 25 then
		demopart = 5
		t = 0
		love.graphics.resetPalette()
		love.graphics.setColor(0,0,0)
		stars_init = 0
	end

	x = 16
	y = 64

	if fade1_d == 0 then
	love.graphics.setColor(math.floor(192*fade1*0.5),math.floor(64*fade1*0.5),math.floor(64*fade1*0.5))
	love.graphics.print("code by visy",x*fade1,y)
	end
	if fade2_d == 0 then
	love.graphics.setColor(math.floor(192*fade2),math.floor(64*fade2*0.5),math.floor(192*fade2*0.5))
	love.graphics.print("featuring music by yzi",x*fade2,y+22)
	end
	if fade3_d == 0 then
	love.graphics.setColor(math.floor(192*fade3*0.5),math.floor(192*fade3*0.5),math.floor(64*fade3*0.5))
	love.graphics.print("pixelations by Zana",x*fade3,y+22*2)
	end
	
	love.graphics.setColor(192,192,192)

	do_stars2()


end

tacc = -2
texts = 1

greets = {
	"greets to",
	"mikkosoft",
	"pyhaen geometrian\nhaepaeisijaet",
	"\nByteraappers",
	"\ntapio B",
	"\nkasettilamerit",
	"\nthereminista",
	"\nbunnies",
}

alku = 0

function do_greets() 

	tacc=tacc + _dt

	if tacc > 1.5 and texts < 8 and alku == 0 then
		tacc = 0
		texts = texts + 1
	end

	if tacc > 4 then
		alku = 1
		no_new_spawn = 1
		texts=8-(tacc-4)*2
		if texts < -11 then
		  	love.audio.stop()
	    	love.event.quit()		
		end
	end

	if texts >= 1 then

	for i=1,texts do
		love.graphics.setColor((i+2)*16,(i+2)*12,(i+2)*13)
		love.graphics.print(greets[i],4,4+(i-1)*22)
	end
	end

end

function love.draw()

--    love.graphics.setCanvas(canvas)
	if firstdraw == 1 then t = 0 end

	firstdraw = 0

	if demopart == 0 then do_city() end
	if demopart == 1 then do_city() do_vector() end
	if demopart == 2 then do_spinner() end
	if demopart == 3 then do_spinner2()  do_stars() end
	if demopart == 4 then do_credits() end
	if demopart == 5 then do_stars() do_greets() end

--    love.graphics.setCanvas()

--    love.graphics.clear()

--    love.graphics.setColor(1, 1, 1, 1.0)

--	effect.crt.time = t

--	effect(function()
--		love.graphics.push()
--		love.graphics.scale(3.0, 3.0)
--	    love.graphics.draw(canvas)
--		love.graphics.pop()
--	end)

end

function love.keypressed(key)
  if key == "escape" then
  	love.audio.stop()
    love.event.quit()
  end
end

function love.update(dt)
	t = t + dt
	vt = vt + dt
	_dt = dt
end